/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.pl.client.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import me.zhyd.oauth.model.AuthUser;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.utils.AuthUtil;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.pl.factory.entity.FactoryEntity;
import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.pl.client.entity.ClientEntity;
import org.springblade.modules.pl.client.vo.ClientVO;
import org.springblade.modules.pl.client.excel.ClientExcel;
import org.springblade.modules.pl.client.wrapper.ClientWrapper;
import org.springblade.modules.pl.client.service.IClientService;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.tool.utils.DateUtil;
import org.springblade.core.excel.util.ExcelUtil;
import org.springblade.core.tool.constant.BladeConstant;
import springfox.documentation.annotations.ApiIgnore;
import java.util.Map;
import java.util.List;
import javax.servlet.http.HttpServletResponse;

/**
 * 客户表 控制器
 *
 * @author BladeX
 * @since 2023-12-05
 */
@RestController
@AllArgsConstructor
@RequestMapping("pl-client/client")
@Api(value = "客户表", tags = "客户表接口")
public class ClientController extends BladeController {

	private final IClientService clientService;

	/**
	 * 客户表 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入client")
	public R<ClientVO> detail(ClientEntity client) {
		ClientEntity detail = clientService.getOne(Condition.getQueryWrapper(client));
		return R.data(ClientWrapper.build().entityVO(detail));
	}
	/**
	 * 客户表 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入client")
	public R<IPage<ClientVO>> list(@ApiIgnore @RequestParam Map<String, Object> client, Query query) {
		query.setDescs("create_time");
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			client.put("factory_id",user.getFactoryId());
		}
		IPage<ClientEntity> pages = clientService.page(Condition.getPage(query), Condition.getQueryWrapper(client, ClientEntity.class));
		return R.data(ClientWrapper.build().pageVO(pages));
	}

	/**
	 * 客户表 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入client")
	public R<IPage<ClientVO>> page(ClientVO client, Query query) {
		IPage<ClientVO> pages = clientService.selectClientPage(Condition.getPage(query), client);
		return R.data(pages);
	}

	/**
	 * 客户表 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入client")
	public R save(@Valid @RequestBody ClientEntity client) {
		return R.status(clientService.save(client));
	}

	/**
	 * 客户表 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入client")
	public R update(@Valid @RequestBody ClientEntity client) {
		return R.status(clientService.updateById(client));
	}

	/**
	 * 客户表 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入client")
	public R submit(@Valid @RequestBody ClientEntity client) {
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			client.setFactoryId(user.getFactoryId());
		}
		return R.status(clientService.saveOrUpdate(client));
	}

	/**
	 * 客户表 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(clientService.deleteLogic(Func.toLongList(ids)));
	}


	/**
	 * 导出数据
	 */
	@GetMapping("/export-client")
	@ApiOperationSupport(order = 9)
	@ApiOperation(value = "导出数据", notes = "传入client")
	public void exportClient(@ApiIgnore @RequestParam Map<String, Object> client, BladeUser bladeUser, HttpServletResponse response) {
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			client.put("factory_id",user.getFactoryId());
		}
		QueryWrapper<ClientEntity> queryWrapper = Condition.getQueryWrapper(client, ClientEntity.class);
		//if (!AuthUtil.isAdministrator()) {
		//	queryWrapper.lambda().eq(Client::getTenantId, bladeUser.getTenantId());
		//}
		queryWrapper.lambda().eq(ClientEntity::getIsDeleted, BladeConstant.DB_NOT_DELETED);
		List<ClientExcel> list = clientService.exportClient(queryWrapper);
		ExcelUtil.export(response, "客户表数据" + DateUtil.time(), "客户表数据表", list, ClientExcel.class);
	}

	/**
	 * 客户表 下拉框
	 */
	@GetMapping("/select")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "下拉框", notes = "传入factory")
	public R<List<ClientEntity>> select(ClientEntity factory, Query query) {
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			factory.setFactoryId(user.getFactoryId());
		}
		List<ClientEntity> list = clientService.list(Condition.getQueryWrapper(factory));
		return R.data(list);
	}

}
